/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIResumableChannel.idl
 */

#ifndef __gen_nsIResumableChannel_h__
#define __gen_nsIResumableChannel_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIStreamListener; /* forward declaration */

class nsIResumableEntityID; /* forward declaration */


/* starting interface:    nsIResumableChannel */
#define NS_IRESUMABLECHANNEL_IID_STR "87cccd68-1dd2-11b2-8b66-cbf10a1b6438"

#define NS_IRESUMABLECHANNEL_IID \
  {0x87cccd68, 0x1dd2, 0x11b2, \
    { 0x8b, 0x66, 0xcb, 0xf1, 0x0a, 0x1b, 0x64, 0x38 }}

class NS_NO_VTABLE nsIResumableChannel : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IRESUMABLECHANNEL_IID)

  /**
     * Prepare this channel for resuming. The request will not start until
     * asyncOpen or open is called. Calling resumeAt after open or asyncOpen
     * has been called has undefined behaviour.
     *
     * @param startPos the starting offset, in bytes, to use to download
     * @param entityID information about the file, to match before obtaining
     *  the file. Pass null to use anything.
     *
     * During OnStartRequest, this channel will have a status of
     *  NS_ERROR_NOT_RESUMABLE if the file cannot be resumed, eg because the
     *  server doesn't support this. This error may occur even if startPos
     *  is 0, so that the front end can warn the user.
     * Similarly, the status of this channel during OnStartRequest may be
     *  NS_ERROR_ENTITY_CHANGED, which indicates that the entity has changed,
     *  as indicated by a changed entityID.
     * In both of these cases, no OnDataAvailable will be called, and
     *  OnStopRequest will immediately follow with the same status code.
     */
  /* void resumeAt (in unsigned long long startPos, in nsIResumableEntityID entityID); */
  NS_IMETHOD ResumeAt(PRUint64 startPos, nsIResumableEntityID *entityID) = 0;

  /**
     * The nsIResumableEntityID for this URI. Available after OnStartRequest.
     * If this attribute is null, then this load is not resumable.
     */
  /* readonly attribute nsIResumableEntityID entityID; */
  NS_IMETHOD GetEntityID(nsIResumableEntityID * *aEntityID) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIRESUMABLECHANNEL \
  NS_IMETHOD ResumeAt(PRUint64 startPos, nsIResumableEntityID *entityID); \
  NS_IMETHOD GetEntityID(nsIResumableEntityID * *aEntityID); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIRESUMABLECHANNEL(_to) \
  NS_IMETHOD ResumeAt(PRUint64 startPos, nsIResumableEntityID *entityID) { return _to ResumeAt(startPos, entityID); } \
  NS_IMETHOD GetEntityID(nsIResumableEntityID * *aEntityID) { return _to GetEntityID(aEntityID); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIRESUMABLECHANNEL(_to) \
  NS_IMETHOD ResumeAt(PRUint64 startPos, nsIResumableEntityID *entityID) { return !_to ? NS_ERROR_NULL_POINTER : _to->ResumeAt(startPos, entityID); } \
  NS_IMETHOD GetEntityID(nsIResumableEntityID * *aEntityID) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEntityID(aEntityID); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsResumableChannel : public nsIResumableChannel
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIRESUMABLECHANNEL

  nsResumableChannel();

private:
  ~nsResumableChannel();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsResumableChannel, nsIResumableChannel)

nsResumableChannel::nsResumableChannel()
{
  /* member initializers and constructor code */
}

nsResumableChannel::~nsResumableChannel()
{
  /* destructor code */
}

/* void resumeAt (in unsigned long long startPos, in nsIResumableEntityID entityID); */
NS_IMETHODIMP nsResumableChannel::ResumeAt(PRUint64 startPos, nsIResumableEntityID *entityID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIResumableEntityID entityID; */
NS_IMETHODIMP nsResumableChannel::GetEntityID(nsIResumableEntityID * *aEntityID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIResumableChannel_h__ */
